from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Int, String, Float

Coval_Filter_Short_Pl_V0_1_0 = CommandToolBuilder(tool="coval_filter_short.pl", base_command=["coval-filter-short.pl"], inputs=[ToolInput(tag="in_ref", input_type=File(optional=True), prefix="--ref", doc=InputDocumentation(doc="reference fasta file used for the alignment")), ToolInput(tag="in_pref", input_type=File(optional=True), prefix="--pref", doc=InputDocumentation(doc="prefix of output file")), ToolInput(tag="in_num", input_type=Int(optional=True), prefix="--num", doc=InputDocumentation(doc="maximum number of mismatches contained in a read [default: 2] (incompatible with --mrate)")), ToolInput(tag="in_m_rate", input_type=Int(optional=True), prefix="--mrate", doc=InputDocumentation(doc="maximum rate of mismatches contained in a read [0..1.0] (incompatible with --num)")), ToolInput(tag="in_var_4", input_type=String(optional=True), prefix="--help", doc=InputDocumentation(doc="")), ToolInput(tag="in_var_5", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_c_oval", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_maximum", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_out_prefix_dot_bam", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_prefix", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_reference", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_fast_a", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_filter", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_13", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_number", input_type=Int(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_of", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_rate", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_file", input_type=File(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_input_sorted_bam_slash_sam_file", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_var_19", input_type=String(), position=2, doc=InputDocumentation(doc="")), ToolInput(tag="in_mismatches", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_used", input_type=String(), position=3, doc=InputDocumentation(doc="")), ToolInput(tag="in_contained", input_type=String(), position=4, doc=InputDocumentation(doc="")), ToolInput(tag="in_for", input_type=String(), position=4, doc=InputDocumentation(doc="")), ToolInput(tag="in_in", input_type=String(), position=5, doc=InputDocumentation(doc="")), ToolInput(tag="in_the", input_type=String(), position=5, doc=InputDocumentation(doc="")), ToolInput(tag="in_a", input_type=String(), position=6, doc=InputDocumentation(doc="")), ToolInput(tag="in_read", input_type=String(), position=7, doc=InputDocumentation(doc="")), ToolInput(tag="in_zero_dot_dot_one_dot_zero", input_type=Float(optional=True), position=8, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_pref", output_type=File(optional=True), selector=InputSelector(input_to_select="in_pref", type_hint=File()), doc=OutputDocumentation(doc="prefix of output file"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Coval_Filter_Short_Pl_V0_1_0().translate("wdl", allow_empty_container=True)

